using System;
using System.IO;
using System.Text;
using System.Collections;
using System.Xml;
using System.Runtime.InteropServices;
using Gtk;
using Gdk;
using Mono.Posix;


public class CheezePadWindow : Gtk.Window {
	//Keeping Track of Styles Etc.	
	public static String NEWDOCSTRING = "(Unsaved Document)";
	public static int number_of_open_windows=0;
	public String open_file_path = "";
	public TextView texty;
	public Statusbar status;
	Gtk.AccelGroup accel_group;
	GlobalKeybinder key_bind;

	public CheezePadWindow (String docString,string Filename) : base (docString)
	{
		accel_group = new Gtk.AccelGroup();
		AddAccelGroup(accel_group);
		number_of_open_windows++;
		VBox main_layout = new VBox(false,0);
		
		texty = new TextView();
		texty.Buffer = new CheezeBuffer(new CheezeStyleSet(),this,CheezeStyleSet.defaultTags);
		
		CheezePadMenu mb = new CheezePadMenu(accel_group,this);
		CheezeToolbar tb = new CheezeToolbar(this,accel_group);
		
		main_layout.PackStart(mb,false,true,0);
		main_layout.PackStart(tb,false,true,0);
		if(number_of_open_windows == 1)
			this.WindowPosition = WindowPosition.Center;
		this.SetDefaultSize (525, 600);
		this.Resizable= true;
		Gtk.ScrolledWindow scrolly = new ScrolledWindow();
				
		status = new Statusbar();
		texty.WrapMode = WrapMode.Char;
		texty.LeftMargin = 40;
		texty.RightMargin = 40;
		System.Console.WriteLine("Here...");
		scrolly.Add(texty);
		main_layout.PackEnd(status,false,true,0);
		main_layout.PackEnd(scrolly,true,true,0);
		this.Add(main_layout);	
		this.DeleteEvent += new DeleteEventHandler (OnCheezePadWindowDelete);
		
		if(Filename != null){
			file_open(texty,Filename);
			this.Title = "CheezePad - "+Filename;
		}
		this.ShowAll ();
	}
void exit_menu_exit(object o, EventArgs args)
	{
		Application.Quit ();
	}
	void file_open(Gtk.TextView tv,string Filename){
		Console.WriteLine("Opening {0}",Filename);
		
		StreamReader open_file = null; 
		try{
			open_file = new System.IO.StreamReader(Filename);
		
		string open_file_path = Filename;
		String cont = "";	
		String c; 
		bool firstline=true;
		while((c = open_file.ReadLine())!=null){
			if(!firstline)
				cont = String.Concat(cont,"\n",c);
			else{
				cont = c;
				firstline=false;
			}
		}	
		open_file.Close();
		tv.Buffer.Text = "";
		CheezeSaver.Deserialize(tv.Buffer,cont);
		} catch(System.IO.FileNotFoundException){
			
		}
	}

	void OnCheezePadWindowDelete (object o, DeleteEventArgs args)
	{
		number_of_open_windows--;
		if(number_of_open_windows==0)
			Application.Quit();
	}
	
	
	
}

public class GlobalKeybinder 
	{
		Gtk.AccelGroup accel_group;
		Gtk.Menu fake_menu;

		public GlobalKeybinder (Gtk.AccelGroup accel_group) 
		{
			this.accel_group = accel_group;

			fake_menu = new Gtk.Menu ();
			fake_menu.AccelGroup = accel_group;
		}

		public void AddAccelerator (EventHandler handler,
					    uint key,
					    Gdk.ModifierType modifiers,
					    Gtk.AccelFlags flags)
		{
			Gtk.MenuItem foo = new Gtk.MenuItem ();
			foo.Activated += handler;
			foo.AddAccelerator ("activate",
					    accel_group,
					    key, 
					    modifiers,
					    flags);
			foo.Show ();

			fake_menu.Append (foo);
		}
	}